;###################################################################################
; SHELLHOOK
; Win95/98/ME, WinNT4/2k/2k3/XP/Vista/7/...
; demo by kero
;###################################################################################

; ListToFile
; GetMessageWindow
; SetSpecialWindow_
; GetSpecialWindow_
; GetSpecialWindows
; EnumChildWindowsProc
; EnumAtomString
; RegisterShellHookWindow_
; DeregisterShellHookWindow_
; RegisterShellHook_
; ShellProc
; OnInit
; DlgProc

;###################################################################################

inclib MACRO x
 include x.inc
 includelib x.lib
endm

;###################################################################################

.386
.model flat,stdcall
option casemap:none

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib shell32
inclib comctl32

.const
  HSHELL_WINDOWCREATED         equ     1
  HSHELL_WINDOWDESTROYED       equ     2
  HSHELL_ACTIVATESHELLWINDOW   equ     3
  HSHELL_WINDOWACTIVATED       equ     4
  HSHELL_GETMINRECT            equ     5
  HSHELL_REDRAW                equ     6
  HSHELL_TASKMAN               equ     7
  HSHELL_LANGUAGE              equ     8
  HSHELL_SYSMENU               equ     9
  HSHELL_ENDTASK               equ    10
  HSHELL_ACCESSIBILITYSTATE    equ    11
  HSHELL_APPCOMMAND            equ    12
  HSHELL_WINDOWREPLACED        equ    13
  HSHELL_WINDOWREPLACING       equ    14
  HSHELL_HIGHBIT               equ  8000h
  HSHELL_RUDEAPPACTIVATED      equ  8004h
  HSHELL_FLASH                 equ  8006h
  RSH_DEREGISTER               equ     0
  RSH_REGISTER                 equ     1
  RSH_REGISTER_PROGMAN         equ     2
  RSH_REGISTER_TASKMAN         equ     3
  WM_LBTRACKPOINT              equ  0131h ; (vs LB_ITEMFROMPOINT)
  HWND_MESSAGE                 equ    -3
  id                           equ   100
  
.data
  _shell32      db "shell32",0
  _user32       db "user32",0
  _rshw         db "RegisterShellHookWindow",0
  _drshw        db "DeregisterShellHookWindow",0
  _gtw          db "GetTaskmanWindow",0  
  _gpw          db "GetProgmanWindow",0
  _gsw          db "GetShellWindow",0
  _stw          db "SetTaskmanWindow",0
  _spw          db "SetProgmanWindow",0
  _ssw          db "SetShellWindow",0
  _sh           db "SHELLHOOK",0
  _cw           db "Current_windows",0
  _escw         db "Enum_and_sort_current_windows",0
  _ecw          db "Enum_current_windows",0 
  _sias         db "System_internal_atom_string_list",0
  _mark         db "=",0
  _next         db  13,10
  _z            db  0
  _caption      db "%5.4lX.%4.4lX  -  ""%s""",0
  _ft           db "%4.3d:  %4.lX   %4.4lX.%4.4lX               ""%s""",0
  _frmt         db "%4.3d:  %4.lX   %4.4lX.%4.4lX  (%4.4lX.%4.4lX)  ""%s""",0
  _frt          db "%5.4lX.%4.4lX  ""%s""",0
  _wintree      db "%5.4lX  %4.4lX.%4.4lX  ""%s"" -- ""%s""",0
  _f            db "%5.4lX  ""%s""",0
  _cnt          db "(%d)",0
  _file         db  "sh_%10.10lu.txt",0
  
.data?
  hinst         HMODULE ?
  hhook         HHOOK ?
  hwin          HWND ?
  hw_test       HWND ?
  rsh_param     dd ?  
  count         dd ?
  WM_SHELLHOOK  dd ?

.code

;###################################################################################

ListToFile proc uses ebx edi esi hWnd:HWND,lpfilename:DWORD

  local	buf[256]:TCHAR
  local	bytes:DWORD

  invoke CreateFile,lpfilename,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
  .if eax!=INVALID_HANDLE_VALUE
    mov ebx,eax
    invoke SetFilePointer,ebx,0,0,FILE_END
    invoke SendMessage,hWnd,LB_GETCOUNT,0,0
    mov esi,eax
    xor edi,edi
    .while edi!=esi
      invoke SendMessage,hWnd,LB_GETTEXT,edi,addr buf
      invoke lstrcat,addr buf,offset _next
      invoke lstrlen,eax
      mov bytes,eax
      invoke WriteFile,ebx,addr buf,bytes,addr bytes,0
      .break .if (!eax)
      inc edi
    .endw
    invoke CloseHandle,ebx
  .endif
  ret
ListToFile endp

;###################################################################################

GetMessageWindow proc uses ebx edi
  xor edi,edi
  invoke FindWindowEx,HWND_MESSAGE,0,0,0   ; for NT>=2k
  test eax,eax
  jz @f
  invoke GetWindowLong,eax,GWL_HWNDPARENT
  mov edi,eax
  jmp @ret
@@:
  invoke GetModuleHandle,0                 ; for Win98, WinMe, NT>=2k
  invoke CreateWindowEx,WS_EX_TOOLWINDOW,32770,0,WS_POPUP,0,0,0,0,HWND_MESSAGE,0,eax,0
  test eax,eax
  jz @f
  push eax
  invoke GetWindowLong,eax,GWL_HWNDPARENT
  mov edi,eax
  call DestroyWindow
  jmp @ret
@@:
  invoke GetModuleHandle,0                ; for Win98, WinMe, NT>=2k
  invoke CreateWindowEx,WS_EX_TOOLWINDOW,32770,0,WS_POPUP,0,0,0,0,0,0,eax,0
  test eax,eax
  jz @ret
  mov ebx,eax
  invoke SetParent,ebx,HWND_MESSAGE
  test eax,eax
  jz @f
  invoke GetWindowLong,ebx,GWL_HWNDPARENT
  mov edi,eax
@@:
  invoke DestroyWindow,ebx
@ret:
  mov eax,edi
  ret
GetMessageWindow endp

;###################################################################################

SetSpecialWindow_ proc hWnd:HWND,lpName:DWORD
  invoke IsWindow,hWnd
  test eax,eax
  jz @f
  invoke GetModuleHandle,offset _user32
  test eax,eax
  jz @f
  invoke GetProcAddress,eax,lpName
  test eax,eax
  jz @f
  push hWnd
  call eax
@@:
  ret
SetSpecialWindow_ endp

;###################################################################################

GetSpecialWindow_ proc lpName:DWORD
  invoke GetModuleHandle,offset _user32
  test eax,eax
  jz @f
  invoke GetProcAddress,eax,lpName
  test eax,eax
  jz @f
  call eax
@@:
  ret
GetSpecialWindow_ endp

;###################################################################################

GetSpecialWindows proc uses ebx edi esi hWnd:HWND

  local buf[256]:TCHAR
  local bu[128]:TCHAR

  push offset _gsw
  push offset _gpw
  push offset _gtw  
  mov edi,id+11
  .while edi<=id+13
    pop eax
    invoke GetSpecialWindow_,eax
    mov ebx,eax    
    .if ebx!=0
      invoke GetClassName,ebx,addr bu,126
    .else
      invoke lstrcpy,addr bu,offset _z
    .endif
    mov edx,ebx
    mov ecx,ebx
    shr ecx,16
    and edx,0FFFFh
    invoke wsprintf,addr buf,offset _frt,ecx,edx,addr bu
    invoke SetDlgItemText,hWnd,edi,addr buf
    inc edi
  .endw
  ret
GetSpecialWindows endp

;###################################################################################

EnumChildWindowsProc proc uses ebx hWnd:HWND,lParam:LPARAM

  local buf1[256]:TCHAR
  local buf2[128]:TCHAR
  local buf3[64]:TCHAR

  .if hWnd!=0
    invoke GetClassLong,hWnd,GCW_ATOM
    mov ebx,eax
    invoke GetClassName,hWnd,addr buf2,126
    invoke SendMessageTimeout,hWnd,WM_GETTEXT,62,addr buf3,SMTO_ABORTIFHUNG,200,0
  .else
    invoke lstrcpy,addr buf2,offset _z
    invoke lstrcpy,addr buf3,offset _z
    xor ebx,ebx
  .endif
  mov ecx,hWnd
  mov edx,ecx
  shr ecx,16
  and edx,0FFFFh
  invoke wsprintf,addr buf1,offset _wintree,ebx,ecx,edx,addr buf2,addr buf3
  invoke SendDlgItemMessage,lParam,id,LB_ADDSTRING,0,addr buf1
  invoke SendDlgItemMessage,lParam,id,LB_SETITEMDATA,eax,hWnd
  xor eax,eax
  inc eax
  ret
EnumChildWindowsProc endp

;###################################################################################

; NT: + registered messages + registered wndclasses.
; 9x: + registered messages only.

EnumAtomString proc uses edi hWnd:HWND,lParam:LPARAM

  local buff[256]:TCHAR
  local buf[242]:TCHAR
  
  mov edi,0C000h
  .while edi<=0FFFFh
    invoke lstrcpy,addr buf,offset _z
    .if lParam==1
      invoke GetClipboardFormatName,edi,addr buf,240
    .else
      invoke GlobalGetAtomName,edi,addr buf,240
    .endif
    .if eax!=0
      invoke wsprintf,addr buff,offset _f,edi,addr buf
      invoke SendDlgItemMessage,hWnd,id,LB_ADDSTRING,0,addr buff
    .endif
    inc edi
  .endw
  invoke SendDlgItemMessage,hWnd,id,LB_GETCOUNT,0,0
  sub eax,1
  invoke wsprintf,addr buf,offset _cnt,eax
  invoke SendDlgItemMessage,hWnd,id,LB_INSERTSTRING,0,addr buf
  invoke SendDlgItemMessage,hWnd,id,LB_INSERTSTRING,0,offset _sias
  ret
EnumAtomString endp

;###################################################################################

RegisterShellHookWindow_ proc hWnd:HWND
  invoke GetModuleHandle,offset _user32
  test eax,eax
  jz @f
  invoke GetProcAddress,eax,offset _rshw
  test eax,eax
  jz @f
  push hWnd
  call eax
@@:
  ret
RegisterShellHookWindow_ endp

;###################################################################################

DeregisterShellHookWindow_ proc hWnd:HWND
  invoke GetModuleHandle,offset _user32
  test eax,eax
  jz @f
  invoke GetProcAddress,eax,offset _drshw
  test eax,eax
  jz @f
  push hWnd
  call eax
@@:
  ret
DeregisterShellHookWindow_ endp

;###################################################################################

RegisterShellHook_ proc hWnd:HWND,lParam:LPARAM

  invoke GetModuleHandle,offset _shell32
  test eax,eax
  jz @f
  invoke GetProcAddress,eax,181 ; ordinal
  test eax,eax
  jz @f
  push lParam
  push hWnd
  call eax
@@:
  ret
RegisterShellHook_ endp

;###################################################################################

ShellProc proc uses ebx edi nCode:UINT,wParam:WPARAM,lParam:LPARAM

  local buf[256]:TCHAR
  local bu[128]:TCHAR
  
  inc count
  invoke lstrcpy,addr bu,offset _z    
  .if wParam!=HSHELL_ACCESSIBILITYSTATE
    invoke IsWindow,wParam
    .if eax!=0
      invoke GetClassName,wParam,addr bu,126
    .endif
  .endif
  mov edx,wParam
  mov ecx,edx
  shr edx,16
  and ecx,0FFFFh      
  mov edi,lParam
  mov ebx,edi
  shr edi,16
  and ebx,0FFFFh
  invoke wsprintf,addr buf,offset _frmt,count,nCode,edx,ecx,edi,ebx,addr bu
  invoke SendDlgItemMessage,hwin,id,LB_ADDSTRING,0,addr buf
  invoke SendDlgItemMessage,hwin,id,LB_SETTOPINDEX,eax,0
;
  invoke CallNextHookEx,hhook,nCode,wParam,lParam
  ret
ShellProc endp

;###################################################################################

OnInit proc hWnd:HWND

  local buf[256]:TCHAR

  mov eax,hWnd
  mov hwin,eax
  mov ecx,eax
  shr eax,16
  and ecx,0FFFFh
  invoke wsprintf,addr buf,offset _caption,eax,ecx,offset _sh
  invoke SetWindowText,hWnd,addr buf
  invoke GetSpecialWindows,hWnd    
  invoke SendDlgItemMessage,hWnd,id,LB_SETHORIZONTALEXTENT,1000,0
  invoke CheckDlgButton,hWnd,id+44,BST_CHECKED
  invoke CheckDlgButton,hWnd,id+71,BST_UNCHECKED
  invoke RegisterWindowMessage,offset _sh
  mov WM_SHELLHOOK,eax
  ret
OnInit endp

;###################################################################################

DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local buff[256]:TCHAR
  local buf[128]:TCHAR
	local bu[4]:DWORD
  local var:DWORD
  local rt:RECT
  local wc:WNDCLASSEX

  mov eax,uMsg
  .if eax==WM_CLOSE
    invoke IsDlgButtonChecked,hWnd,id+1
    .if eax==BST_CHECKED && hhook!=0
      invoke UnhookWindowsHookEx,hhook
    .endif
    invoke IsDlgButtonChecked,hWnd,id+2
    .if eax==BST_CHECKED
      invoke DeregisterShellHookWindow_,hWnd
    .endif
    invoke IsDlgButtonChecked,hWnd,id+3
    .if eax==BST_CHECKED
      invoke RegisterShellHook_,hWnd,RSH_DEREGISTER
    .endif
    invoke EndDialog,hWnd,0

  .elseif eax==WM_COMMAND && wParam==id+1
    invoke IsDlgButtonChecked,hWnd,wParam
    .if eax==BST_CHECKED
      invoke GetCurrentThreadId
      invoke SetWindowsHookEx,WH_SHELL,addr ShellProc,0,eax
      mov hhook,eax
    .else
      .if hhook!=0
        invoke UnhookWindowsHookEx,hhook
        mov hhook,eax
      .else
        xor eax,eax
        dec eax
      .endif
    .endif
    invoke GetSpecialWindows,hWnd

  .elseif eax==WM_COMMAND && wParam==id+2
    invoke IsDlgButtonChecked,hWnd,wParam
    .if eax==BST_CHECKED
      invoke RegisterShellHookWindow_,hWnd
    .else
      invoke DeregisterShellHookWindow_,hWnd
    .endif
    invoke GetSpecialWindows,hWnd

  .elseif eax==WM_COMMAND && wParam>=id+50 && wParam<=id+53
    mov eax,wParam
    sub eax,id+50
    mov rsh_param,eax
    .if eax!=0
      mov eax,BST_CHECKED
    .endif
    invoke CheckDlgButton,hWnd,id+3,eax
    invoke RegisterShellHook_,hWnd,rsh_param
    invoke GetSpecialWindows,hWnd

    .if wParam!=id+50
      invoke SetDlgItemText,hWnd,wParam,offset _mark
    .else
      mov edi,id+51
      .while edi<=id+53
        invoke SetDlgItemText,hWnd,edi,0
        inc edi
      .endw
    .endif

  .elseif eax==WM_COMMAND && wParam==id-1
    xor eax,eax
    mov count,eax
    invoke SendDlgItemMessage,hWnd,id,LB_RESETCONTENT,eax,eax

  .elseif eax==WM_COMMAND && wParam==id-3
    invoke SendDlgItemMessage,hWnd,id,LB_RESETCONTENT,0,0
    invoke EnumAtomString,hWnd,1

  .elseif eax==WM_COMMAND && wParam==id-8
    invoke GetTickCount
    invoke wsprintf,addr buff,offset _file,eax
    invoke GetDlgItem,hWnd,id
    mov edx,eax
    invoke ListToFile,edx,addr buff

  .elseif eax==WM_TIMER
    xor ebx,ebx
@@:
    invoke GetAsyncKeyState,VK_SHIFT
    and eax,8000h
    .if eax==0 && ebx==0
      jmp @f
    .elseif eax!=0
      invoke Sleep,10
      xor ebx,ebx
      inc ebx
      jmp @b
    .endif
    jmp @@@
@@:

  .elseif eax==WM_COMMAND && wParam==id+71
    invoke IsDlgButtonChecked,hWnd,id+71
    .if eax!=BST_UNCHECKED
      invoke GetDlgItem,hWnd,id
      mov ebx,eax
      invoke GetWindowRect,ebx,addr rt
      invoke MapWindowPoints,0,hWnd,addr rt,2
      invoke GetClassLong,ebx,GCW_ATOM
      mov var,eax
      invoke GetWindowLong,ebx,GWL_STYLE
      mov edi,eax
      xor edi,LBS_SORT
      invoke GetWindowLong,ebx,GWL_EXSTYLE
      mov esi,eax
      invoke DestroyWindow,ebx
      mov ecx,rt.right
      sub ecx,rt.left
      mov edx,rt.bottom
      sub edx,rt.top
      invoke CreateWindowEx,esi,var,0,edi,rt.left,rt.top,ecx,edx,hWnd,id,hinst,0
      mov ebx,eax
      invoke SendMessage,ebx,LB_SETHORIZONTALEXTENT,1000,0
      invoke SendMessage,hWnd,WM_GETFONT,0,0
      invoke SendMessage,ebx,WM_SETFONT,eax,0
    .endif
    jmp @@@
    
  .elseif eax==WM_COMMAND && wParam==id-2
@@@:
    invoke SendDlgItemMessage,hWnd,id,LB_RESETCONTENT,0,0
    invoke EnumChildWindowsProc,0,hWnd
    invoke IsDlgButtonChecked,hWnd,id+71
    mov var,eax
    .if eax!=BST_INDETERMINATE
      invoke GetDesktopWindow
      mov ebx,eax
      invoke EnumChildWindowsProc,ebx,hWnd
      invoke EnumChildWindows,ebx,offset EnumChildWindowsProc,hWnd
      invoke GetMessageWindow
      test eax,eax
      jz @f
      mov ebx,eax
      invoke EnumChildWindowsProc,ebx,hWnd
      invoke EnumChildWindows,ebx,offset EnumChildWindowsProc,hWnd
@@:
    .else
      xor edi,edi
      .while edi<=0FFFFh
        invoke IsWindow,edi
        test eax,eax
        jz @f
        invoke EnumChildWindowsProc,edi,hWnd
@@:
        inc edi
      .endw
    .endif
    invoke SendDlgItemMessage,hWnd,id,LB_GETCOUNT,0,0
    dec eax
    invoke wsprintf,addr buff,offset _cnt,eax
    invoke SendDlgItemMessage,hWnd,id,LB_INSERTSTRING,0,addr buff
    mov eax,var
    .if eax==BST_UNCHECKED
      mov eax,offset _ecw
    .elseif eax==BST_CHECKED
      mov eax,offset _escw
    .else ; if eax==BST_INDETERMINATE
      mov eax,offset _cw
    .endif
    invoke SendDlgItemMessage,hWnd,id,LB_INSERTSTRING,0,eax

  .elseif eax==WM_COMMAND && wParam==id+70
    invoke IsDlgButtonChecked,hWnd,wParam
    .if eax==BST_CHECKED
      invoke SetTimer,hWnd,id,100,0
    .else
      invoke KillTimer,hWnd,id
    .endif

  .elseif eax==WM_SHELLHOOK && eax!=0
    inc count
    invoke lstrcpy,addr buf,offset _z    
    .if lParam!=HSHELL_ACCESSIBILITYSTATE
      invoke IsWindow,lParam
      .if eax!=0
        invoke GetClassName,lParam,addr buf,126
      .endif
    .endif
    mov ecx,lParam
    mov edx,ecx
    shr ecx,16
    and edx,0FFFFh
    invoke wsprintf,addr buff,offset _ft,count,wParam,ecx,edx,addr buf
    invoke SendDlgItemMessage,hWnd,id,LB_ADDSTRING,0,addr buff
    invoke SendDlgItemMessage,hWnd,id,LB_SETTOPINDEX,eax,0

  .elseif eax==WM_LBTRACKPOINT
    invoke SendDlgItemMessage,hWnd,id,LB_GETITEMDATA,wParam,0
    mov ebx,eax
    invoke IsWindow,ebx
    .if eax==0
      xor ebx,ebx
      invoke lstrcpy,addr buf,offset _z
      jmp @f
    .endif
    invoke GetClassName,ebx,addr buf,126
@@:
    mov hw_test,ebx
    mov edx,ebx
    mov ecx,ebx
    shr ecx,16
    and edx,0FFFFh
    invoke wsprintf,addr buff,offset _frt,ecx,edx,addr buf
    invoke SetDlgItemText,hWnd,id+14,addr buff
    xor edi,edi
    invoke IsDlgButtonChecked,hWnd,id+41
    .if eax==BST_CHECKED
      mov edi,offset _stw
    .else
      invoke IsDlgButtonChecked,hWnd,id+42
      .if eax==BST_CHECKED
        mov edi,offset _spw
      .else
        invoke IsDlgButtonChecked,hWnd,id+43
        .if eax==BST_CHECKED
          mov edi,offset _ssw
        .endif
      .endif
    .endif
    .if edi!=0
      invoke SetSpecialWindow_,ebx,edi
    .endif
    invoke GetSpecialWindows,hWnd

  .elseif eax==WM_SIZE
    mov edi,lParam
    and edi,0FFFFh
    xor esi,esi
    push id
    push id+11
    push id+12
    push id+13
    push id+14
    push id+72
    .while esi<=5
      pop eax
      invoke GetDlgItem,hWnd,eax
      mov ebx,eax
      invoke GetWindowRect,ebx,addr rt
      invoke MapWindowPoints,0,hWnd,addr rt,2
      mov ecx,rt.bottom
      sub ecx,rt.top
      mov edx,edi
      sub edx,rt.left
      sub edx,9
      invoke SetWindowPos,ebx,0,0,0,edx,ecx,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED
      inc esi
    .endw

  .elseif eax==WM_LBUTTONDOWN
    invoke PostMessage,hWnd,WM_SYSCOMMAND,SC_SIZE+9,0

  .elseif eax==WM_INITDIALOG
    invoke OnInit,hWnd

	.else
    xor eax,eax
    jmp @ret
  .endif
  xor eax,eax
  inc eax
@ret:
  ret
DlgProc endp

;###################################################################################

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke DialogBoxParam,eax,id,0,offset DlgProc,0
  invoke ExitProcess,eax
  invoke InitCommonControls
  invoke DragFinish,0
end start

;###################################################################################
